from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.3')

loadImage = TEMUSupport.temu_loadImage
loadImage.argtypes = [c_void_p, c_char_p]
loadImage.restype = c_int

loadImageAndStartAddr = TEMUSupport.temu_loadImageAndStartAddr
loadImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint64)]
loadImageAndStartAddr.restype = c_int

loadBinaryImage = TEMUSupport.temu_loadBinaryImage
loadBinaryImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadBinaryImage.restype = c_int

loadElfImage = TEMUSupport.temu_loadElfImage
loadElfImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadElfImage.restype = c_int

loadElfImageAndStartAddr = TEMUSupport.temu_loadElfImageAndStartAddr
loadElfImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint64)]
loadElfImageAndStartAddr.restype = c_int

imageIsELF = TEMUSupport.temu_imageIsELF
imageIsELF.argtypes = [c_char_p]
imageIsELF.restype = c_int

elfHasDwarf = TEMUSupport.temu_elfHasDwarf
elfHasDwarf.argtypes = [c_char_p]
elfHasDwarf.restype = c_int

loadSymtab = TEMUSupport.temu_loadSymtab
loadSymtab.argtypes = [c_char_p, POINTER(c_void_p)]
loadSymtab.restype = c_int

symtabGetFuncName = TEMUSupport.temu_symtabGetFuncName
symtabGetFuncName.argtypes = [c_void_p, POINTER(c_char_p), POINTER(c_char_p), c_uint64]
symtabGetFuncName.restype = None

symtabGetObjName = TEMUSupport.temu_symtabGetObjName
symtabGetObjName.argtypes = [c_void_p, POINTER(c_char_p), POINTER(c_char_p), c_uint64]
symtabGetObjName.restype = None

symtabGetGlobalFuncRange = TEMUSupport.temu_symtabGetGlobalFuncRange
symtabGetGlobalFuncRange.argtypes = [c_void_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetGlobalFuncRange.restype = c_int

symtabGetLocalFuncRange = TEMUSupport.temu_symtabGetLocalFuncRange
symtabGetLocalFuncRange.argtypes = [c_void_p, c_char_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetLocalFuncRange.restype = c_int

symtabGetGlobalObjRange = TEMUSupport.temu_symtabGetGlobalObjRange
symtabGetGlobalObjRange.argtypes = [c_void_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetGlobalObjRange.restype = c_int

symtabGetLocalObjRange = TEMUSupport.temu_symtabGetLocalObjRange
symtabGetLocalObjRange.argtypes = [c_void_p, c_char_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetLocalObjRange.restype = c_int

disposeSymtab = TEMUSupport.temu_disposeSymtab
disposeSymtab.argtypes = [c_void_p]
disposeSymtab.restype = None

loadSrecImage = TEMUSupport.temu_loadSrecImage
loadSrecImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadSrecImage.restype = c_int

loadSrecImageAndStartAddr = TEMUSupport.temu_loadSrecImageAndStartAddr
loadSrecImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint32)]
loadSrecImageAndStartAddr.restype = c_int

from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.3')

loadImage = TEMUSupport.temu_loadImage
loadImage.argtypes = [c_void_p, c_char_p]
loadImage.restype = c_int

loadImageAndStartAddr = TEMUSupport.temu_loadImageAndStartAddr
loadImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint64)]
loadImageAndStartAddr.restype = c_int

loadBinaryImage = TEMUSupport.temu_loadBinaryImage
loadBinaryImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadBinaryImage.restype = c_int

loadElfImage = TEMUSupport.temu_loadElfImage
loadElfImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadElfImage.restype = c_int

loadElfImageAndStartAddr = TEMUSupport.temu_loadElfImageAndStartAddr
loadElfImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint64)]
loadElfImageAndStartAddr.restype = c_int

imageIsELF = TEMUSupport.temu_imageIsELF
imageIsELF.argtypes = [c_char_p]
imageIsELF.restype = c_int

elfHasDwarf = TEMUSupport.temu_elfHasDwarf
elfHasDwarf.argtypes = [c_char_p]
elfHasDwarf.restype = c_int

loadSymtab = TEMUSupport.temu_loadSymtab
loadSymtab.argtypes = [c_char_p, POINTER(c_void_p)]
loadSymtab.restype = c_int

symtabGetFuncName = TEMUSupport.temu_symtabGetFuncName
symtabGetFuncName.argtypes = [c_void_p, POINTER(c_char_p), POINTER(c_char_p), c_uint64]
symtabGetFuncName.restype = None

symtabGetObjName = TEMUSupport.temu_symtabGetObjName
symtabGetObjName.argtypes = [c_void_p, POINTER(c_char_p), POINTER(c_char_p), c_uint64]
symtabGetObjName.restype = None

symtabGetGlobalFuncRange = TEMUSupport.temu_symtabGetGlobalFuncRange
symtabGetGlobalFuncRange.argtypes = [c_void_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetGlobalFuncRange.restype = c_int

symtabGetLocalFuncRange = TEMUSupport.temu_symtabGetLocalFuncRange
symtabGetLocalFuncRange.argtypes = [c_void_p, c_char_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetLocalFuncRange.restype = c_int

symtabGetGlobalObjRange = TEMUSupport.temu_symtabGetGlobalObjRange
symtabGetGlobalObjRange.argtypes = [c_void_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetGlobalObjRange.restype = c_int

symtabGetLocalObjRange = TEMUSupport.temu_symtabGetLocalObjRange
symtabGetLocalObjRange.argtypes = [c_void_p, c_char_p, c_char_p, POINTER(c_uint64), POINTER(c_uint64)]
symtabGetLocalObjRange.restype = c_int

disposeSymtab = TEMUSupport.temu_disposeSymtab
disposeSymtab.argtypes = [c_void_p]
disposeSymtab.restype = None

loadSrecImage = TEMUSupport.temu_loadSrecImage
loadSrecImage.argtypes = [c_void_p, c_char_p, c_uint64]
loadSrecImage.restype = c_int

loadSrecImageAndStartAddr = TEMUSupport.temu_loadSrecImageAndStartAddr
loadSrecImageAndStartAddr.argtypes = [c_void_p, c_char_p, POINTER(c_uint32)]
loadSrecImageAndStartAddr.restype = c_int

